#include <stdio.h>
#include <stdlib.h>
#include "utils.h"
#include "jmalloc.h"
#include "configure.h"

#define DEFAULT_HARDCODED_BD_PATH "/tmp/backdoor"
#define DEFAULT_HARDCODED_EXT     ".exe"

ip_entry_t *ip_entry_head=NULL;
const char *infect_file_log=NULL;
struct memory_pool_desc *g_ip_pool=NULL;
static char *default_bd=DEFAULT_HARDCODED_BD_PATH;
static char *default_extension=DEFAULT_HARDCODED_EXT;

char *g_mode_map[] = { "Unkown Map", "[Decoy]", "[Inject]", "[Reject]" ,"[Proxy]", NULL };

static char* skip_line_and_test(char *line, char *end)
{
  char *ret = skip_line(line);
  if( ret >= end )
    return NULL;

  return ret;
}

static char *skip_empty_line(char *line, char *end, int *skipped)
{
  int line_skipped = 0;
  char *tmp = line;
  while( is_empty(tmp) )
  {
    tmp = skip_line_and_test(tmp, end);
    if( tmp == NULL )
      return NULL;

    line_skipped++;

  }

  *skipped = line_skipped;
  return tmp;
}


#define MAX_OPT_ENTRY 128
static int get_ip_range(char *entry, unsigned int *start, unsigned int *fini)
{
  int level=3,i,j; 
  unsigned int begin=0, end=0;
  char ip[4];
 
  i=0; 
  while(level >= 0)
  {
    memset(ip, 0x00, 4);
    if(entry[i] == '*')
    {
      ip[0] = '*';
      break;
    }

    for(j=0; j < 3; i++,j++)
    {
      if( !isdigit(entry[i]) && (entry[i] != '.') && ( (entry[i] == 0 && j == 0) || (entry[i] == 0 && level != 0) ) ) // syntax error
        return 0;

      if(entry[i] == '.')
        break;

      else
        ip[j] = entry[i];
    }
   
    if(ip[0] != '*') // process classical octect
    {
      int num = atoi(ip); 
      begin += num << (8*level);
    }
    else /* with wildcards break */
    {
      level--;
      break;
    }

    level--, i++;
  }

  if(level >= 0) /* there is wildcards */
    end = begin + (1 << ((level+1)*8))-1; 
  else
    end = begin;

  *start = begin;
  *fini  = end;

  return 1;

}

static int get_ext_info_tag(const char *ext)
{
  if( ext[0] == '*' )
  {
    D_LOG(MSG_DEBUG, "Extension Added: default: %s", default_extension); 
    ext = default_extension;
  }

  
  if( !strcmp(ext, ".exe") )
  {
    D_LOG(MSG_DEBUG, "Extension Added: .exe");
    return EXT_EXE;
  }
  else if( !strcmp(ext, ".rpm") )
  {
    D_LOG(MSG_DEBUG, "Extension Added: .rpm");
    return EXT_RPM;
  } 

  return 0;
}


static int get_ext_info(const char *ext_info)
{
  int i=0,j;
  char ext[6];
  int ret = 0;

  if( ext_info[0] == '*' )
    return get_ext_info_tag(default_extension);
  
  do 
  {
    memset(ext, 0x00, sizeof(ext));
    for(j=0; j < sizeof(ext)-1 && ext_info[i] != SPACE && ext_info[i] != O_TAB && ext_info[i] != '\n' && ext_info[i] != ','; i++)
    {
      ext[j++] = ext_info[i]; 
    }

    if(ext[0] != '.')
    {
      D_LOG(MSG_ERROR, "Parsing Extension Syntax Error");
      return -1; 
    }
    else if(ext[0] == '{')
    {
      D_LOG(MSG_ERROR, "Text Match Not Supported {match...}, use Extension");
      return -1; 
    }
    
    ret |= get_ext_info_tag(ext);

  } while(ext_info[i++] == ',');

  return ret;
}


static inline int is_last(const char* eof)
{
  if(eof[0] == '\n')
    return 1;
  else
    return 0; 
}

static ip_entry_t *parse_new_entry(char *base, int mode)
{
  int ret;
  unsigned int start,end, ext_info;
  size_t max_file_size, max_infect;
  char *bd_path=NULL;
  ip_entry_t* ip;
  char entry[MAX_OPT_ENTRY];
  
  const char *tok=NULL, *next_tok=base;

  tok = get_next_token(next_tok, &next_tok, entry, sizeof(entry));
  if(!tok)
    return NULL;
  
  if(!strcmp("default", entry))
  {
    if(mode == J_MODE_INJECT)
    {
      D_LOG(MSG_ERROR, "Incorrect use of \"default\" keyword in [inject] mode");
      return NULL;
    }
    start = 0;
    end   = 0xFFFFFFFFU;
  }
  else 
  {
    ret = get_ip_range(entry, &start, &end);
    if( !ret )
      return NULL;
  }

  /* if mode inject set up args */
  if(mode == J_MODE_INJECT)
  {
    tok = get_next_token(next_tok, &next_tok, entry, sizeof(entry)); 
    if( !tok || !next_tok )
      return NULL;
    if( entry[0] == '*' )
      bd_path = strdup(default_bd);
    else
      bd_path = strdup(entry);
    
    
    tok = get_next_token(next_tok, &next_tok, entry, sizeof(entry)); 
    if( !tok || !next_tok )
      return NULL;
    ext_info = get_ext_info(entry);
    if( ext_info == -1 )
      return NULL;
   

    tok = get_next_token(next_tok, &next_tok, entry, sizeof(entry)); 
    if( !tok || !next_tok )
      return NULL;
    max_file_size = atoi(entry);   
 
    
    tok = get_next_token(next_tok, &next_tok, entry, sizeof(entry)); 
    if( !tok )
      return NULL;
    max_infect = atoi(entry);   
    
    ip = get_ip_entry(start, end, mode, bd_path, ext_info, NULL, 0, max_file_size, max_infect); // no size limit
    free(bd_path);
  }
  else
    ip = get_ip_entry(start, end, mode, NULL, 0, NULL, 0, 0, 0); 
  
  
  return ip;
}


#define MAX_OPT_MODE 16
static char *process_range_mode(char *base, char *end, int *skipped)
{
  int i,j;
  unsigned int j_mode, line_num=0;

  char mode[MAX_OPT_MODE];
  memset(mode, 0x00, MAX_OPT_MODE);

  assert(*base == '[');
  base++;

  for(i=0,j=0; base[i] != ']' && i < MAX_OPT_MODE; i++, j++)
    mode[j] = base[i];
 
  base = skip_line_and_test(base, end);
  if( !base )
    return NULL;  

  line_num++;

  if(!strcmp("decoy", mode))
  {
    D_LOG(MSG_INFO, "Processing mode: %s", mode);
    j_mode = J_MODE_DECOY; 
  }
  else if(!strcmp("inject", mode))
  { 
    D_LOG(MSG_INFO, "Processing mode: %s", mode);
    j_mode = J_MODE_INJECT;
  }
  else if(!strcmp("reject", mode))
  {
    D_LOG(MSG_INFO, "Processing mode: %s", mode);
    j_mode = J_MODE_REJECT;
  }
  else if(!strcmp("proxy", mode))
  {
    D_LOG(MSG_INFO, "Processing mode: %s", mode);
    j_mode = J_MODE_PROXY;
  }
  else 
  {
    D_LOG(MSG_ERROR, "Unknown Mode: %s", mode);
    while(!is_empty(base))
    {
      base = skip_line_and_test(base, end);
      D_LOG(MSG_ERROR, "Skipping Mode %s entry", mode);

      line_num++;
      if(!base)
        return NULL;

      return base;
    }
  }

  /* try getting entry ... */
  while(!is_empty(base))
  {
    ip_entry_t* ip = parse_new_entry(base, j_mode);  
    if( !ip )
    {
      base = skip_line_and_test(base, end);
      break;  
    }

    D_LOG(MSG_INFO, "Ip Entry: range: %x-%x, mode: %s, bdpath: %s, max_size: %d, maxinfect: %d", 
                      ip->start, ip->end, g_mode_map[j_mode], ip->bd_path, ip->max_file_size, ip->max_infect);

    add_ip_entry(ip);
    
    base = skip_line_and_test(base, end);
    if( !base )
      break;

    line_num++;

    // TODO add ip entry to the head...
  }
  
  *skipped = line_num;

  return base;
        
}


static char *process_comment(char *base, char *end)
{
  char *str = get_str_from_mem_line(base); 
  D_LOG(MSG_DEBUG, "Skipping Comment: %s", str);

  jfree(str);

  return skip_line_and_test(base, end);
  
}

#define MAX_OPT_SIZE 32
#define MAX_OPT_ARG  128
static char *process_option(char *base, char *end)
{
  int i,j;
  char option[MAX_OPT_SIZE];
  char opt_arg[MAX_OPT_ARG];
  memset(option, 0x00, MAX_OPT_SIZE);
  memset(opt_arg, 0x00, MAX_OPT_ARG);

  for(j=0,i=0; i<MAX_OPT_SIZE-1 && base[i] != '='; i++, j++)
    option[j] = base[i];

  i++; // skip '='

  for(j=0; i<MAX_OPT_SIZE-1 && base[i] != '\n' && base[i] != SPACE && base[i] != O_TAB; i++, j++)
    opt_arg[j] = base[i];

  if(!strcmp(option, "default_backdoor"))
  {
    default_bd = strdup(opt_arg); 
    D_LOG(MSG_INFO, "Setting Default Backdoor to: %s", opt_arg);
  }
  else if(!strcmp(option, "default_extension"))
  {
    default_extension = strdup(opt_arg);
    D_LOG(MSG_INFO, "Setting Default Extesion to: %s", opt_arg);
  }
  else if(!strcmp(option, "infect_file_log"))
  {
    infect_file_log = strdup(opt_arg); 
    D_LOG(MSG_INFO, "Setting Infected Ip-Range Output File: %s", opt_arg);
  }
  else
  {
    D_LOG(MSG_ERROR, "Unknown Option: %s", option);
  }
        
  return skip_line_and_test(base, end);
}


#define TMP_MAPPING "/tmp/jproxy_mapping"
int parse_config_mem(char *mem, size_t size)
{
  char *base = mem, *end = mem+size; 
  int line_num=1, skipped;

  g_ip_pool = create_mapping_pool(TMP_MAPPING, sizeof(ip_entry_t), 100);
  if( !g_ip_pool )
  {
    D_LOG(MSG_ERROR, "Unable to Create Pool: can't open/remove /tmp/jproxy_mapping");
    return 0;
  }
  
  do 
  {
    base = skip_empty_line(base, end, &skipped); 
    if( base == NULL )
      break;

    line_num += skipped;

    if( *base == '[' )  {
      base = process_range_mode(base, end, &skipped);
      line_num += skipped;
    }
    else if( *base == '#' )
    {
      base = process_comment(base, end);
      line_num++;
    }
    else if(isalpha( *base) ) {
      base = process_option(base, end);
      line_num++;
    }
    else
    {
      D_LOG(MSG_ERROR, "Line Error at Line %d", line_num);
      base = skip_line(base);
      line_num++;
    }
    
  } while( base );
  

  return 1;
}


int parse_config_file(const char *file_path)
{
  int i=0, ret;
  FILE *conf =  fopen(file_path, "r");
  if(!conf)
  {
    D_LOG(MSG_ERROR, "Unable To Open Config File: %s", file_path);
    return 0;
  }
  size_t size = get_file_size(fileno(conf));

  /* erease old config */
  remove_whole_ip_entry();
  
  char *mem = jmalloc(size);
  if( !mem )
    return 0;

  memset(mem, 0x00, size);

  while( (ret = fgetc(conf)) != EOF )
    mem[i++] = (unsigned char)ret;
    
          
  return parse_config_mem(mem, size);
}


