#ifndef J_LOG_H
#define J_LOG_H
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

/* active debugging */
#define J_DEBUG

/* message type */
#define MSG_ERROR   "ERROR"
#define MSG_WARNING "WARNING"
#define MSG_DEBUG   "DEBUG"
#define MSG_INFO    "INFO"

#ifndef J_DEBUG_DEEP
#define NOT_DEBUG_DEEP(type) if( type == MSG_DEBUG) break; 
#else
#define NOT_DEBUG_DEEP(type)
#endif

// TODO: fix race between fprintf
#ifdef J_DEBUG
#define D_LOG(type, ...) do { int p = getpid(); \
                              NOT_DEBUG_DEEP(type) \
                              fprintf(stderr, "==%d== %s():%d => [%s] ", p, __func__, __LINE__, type); \
                              fprintf(stderr, ##__VA_ARGS__); \
                              fprintf(stderr, "\n"); \
                      } while(0)
#else
#define D_LOG(...)
#endif

#endif

