#ifndef LINE_BUFFER_H
#define LINE_BUFFER_H

#include <sys/types.h>

typedef struct line_buffer_s
{
  char *ln_buff;
  const char *ln_term;
  size_t ln_buff_size;
  size_t used;

} line_buffer_t;



extern line_buffer_t *create_lb(size_t size, const char *line_terminator);
extern void destroy_lb(line_buffer_t *lb);

/* return NULL if there is no line in the buffer */
extern char *lb_query_line(line_buffer_t *lb, size_t *len);
extern char *lb_query_last(line_buffer_t *lb, size_t *len);
extern const char *lb_insert_data(line_buffer_t *lb, const char* data, size_t len, size_t *discarded);



#endif
